package example.reporter;

import java.net.Socket;

import org.eclipse.aperi.agent.handler.IAgentRequestHandler;
import org.eclipse.aperi.agent.reporter.IReporter;
import org.eclipse.aperi.agent.svp.Agent;
import org.eclipse.aperi.constants.RequestType;
import org.eclipse.aperi.constants.ServerServiceHandler;
import org.eclipse.aperi.constants.metadata.RequestTypeManager;
import org.eclipse.aperi.request.Request;
import org.eclipse.aperi.request.Response;
import org.eclipse.aperi.server.req.ServerStatusResp;
import org.eclipse.aperi.xmsg.MessageLog;

public class Reporter implements IAgentRequestHandler {

	public void handle(Request request, Response response, Socket connection) {
		
		// Sample Request
		// The server status is a simple request so I'll grab the server memory.
		Request serverRequest = new Request();
		serverRequest.typeCode = RequestType.SERVER;
		serverRequest.subType = ServerServiceHandler.SERVER_STATUS;
		serverRequest.serviceName = RequestTypeManager.getInternalName(serverRequest.typeCode);
		serverRequest.machineName = Agent.localName;
		
		// Send the request using the reporter
		Response serverResponse = Agent.reporter.sendRequest(serverRequest, IReporter.RETRY_NEVER);
		if(serverResponse != null && serverResponse.status <= Response.WARNING)
		{
			ServerStatusResp serverStatus = (ServerStatusResp) serverResponse.responseData;
			
			// Write to the agent log
			MessageLog.logMessage("HWM0001I", serverStatus.totalMemory);
		}
		response.status = Response.SUCCESS;
		
	}

}
